Compare commits

...
Author SHA1 Message Date
Serge Schneider 0d34fb9439 Update release notes 2018-06-19 15:29:57 +01:00
Serge Schneider 8e7faf7fba stage4: install libreoffice-pi instead of libreoffice 2018-06-19 15:29:57 +01:00
Serge Schneider 3c3528aaf0 stage5: add latest MagPi issue 2018-06-19 15:29:57 +01:00
Serge Schneider 1445894c2e stage4: Add piwiz and rp-prefapps
Remove claws-mail, greenfoot, bluej, nodered & realvnc-vnc-server
2018-06-19 13:57:14 +01:00
Hugo Hromic 8d9cfb3e46 stage0: add missing raspberrypi-kernel package to the firmware sub stage (#185) 2018-06-04 09:44:31 +01:00
Hugo Hromic fea9e2945a export-image: clean additional backup files (#186) 2018-06-04 09:43:42 +01:00
Hugo Hromic 9d76d3a6a2 stage2: clean unused/obsolete patch (#187) 2018-06-04 09:42:52 +01:00
Hugo Hromic df156f02ff stage1: add missing netbase package to the net-tweaks sub stage 2018-05-08 08:43:55 +01:00
Serge Schneider 4a5ecb6180 export-noobs: bump kernel version in os.json 2018-04-24 09:10:29 +01:00
Serge Schneider 1f51b8bd18 stage3: switch from xpdf to qpdfview 2018-04-24 08:48:27 +01:00
Serge Schneider d6c238c1b2 Update release notes 2018-04-17 13:33:04 +01:00
Serge Schneider 93db373672 sources.list: change {mirrordirector,archive}.raspbian.org to raspbian.raspberrypi.org 2018-03-28 10:58:28 +01:00
David Steele 555417bbe6 Fix some quoted globs in export-image cleanup (#173) 2018-03-26 13:06:10 +01:00
David Steele 75452f9a00 Add README detail on the 'patches' process (#170) 2018-03-24 18:10:47 +00:00
David Steele 343cabc8f5 Remove quotes in globbed patch CLEANup (#168)
Globbing does not work within single or double quotes.
https://unix.stackexchange.com/questions/67757/wildcards-inside-quotes
2018-03-24 17:36:18 +00:00
David Steele de5b2baa1c README.md: Clarify USE_QEMU (#165) 2018-03-19 19:17:58 +00:00
Serge Schneider 589afcc72d Update release notes 2018-03-15 14:29:28 +00:00
Serge Schneider ff2d5edee1 shellcheck 2018-03-13 12:50:50 +00:00
Serge Schneider 56da271499 Remove unnecessary files 2018-03-13 12:37:13 +00:00
Junian Triajianto 019d47db3b Update stage specification using SKIP_IMAGES (#163)
Change Stage specification guide from removing `EXPORT*` files to adding `SKIP_IMAGES` as per new recommended development process.
2018-03-13 10:20:22 +00:00
andig b4035400ff Add option to preserve build container (#160) 2018-03-05 15:35:11 +00:00
Serge Schneider 4d689a25fd export-image: don't round up if already a multiple of 4MB
Fixes #156
2018-03-01 18:02:01 +00:00
James Ruan 40eae05204 make root filesystem 4M aligned (#154) 2018-03-01 17:52:26 +00:00
Serge Schneider e6f7cd5cd6 stage2: don't set 'country' in wpa_supplicant.conf 2018-03-01 15:54:13 +00:00
Serge Schneider c430f618d0 Remove ld.so.preload and policy-rc.d changes 2018-03-01 15:54:12 +00:00
Serge Schneider 4c7980fa1e stage4: drop 'Documents' directory
Closes #121
2018-03-01 15:54:12 +00:00
Serge Schneider 702b3e7e80 stage3: install obconf 2018-03-01 15:54:12 +00:00
Philip Howard cace22768a Added Button SHIM, Unicorn HAT HD and Pan Tilt HAT (#159) 2018-03-01 13:58:09 +00:00
Ben Pirt 066eb03d52 Allow image building to be skipped for stages (#137) 2018-01-03 12:48:31 +00:00
andig 40e5dae819 Correct help text (#145) 2018-01-02 18:17:07 +00:00
Ben Pirt 6e32569415 Update README with some information on how the build works (#136) 2017-12-15 11:31:40 +00:00
Serge Schneider 13185c8224 stage2: install policykit-1
Closes #116
2017-12-13 11:17:58 +00:00
Serge Schneider b71bf31793 Update os.json 2017-11-24 10:12:09 +00:00
Serge Schneider 4b08ad07b1 Update release notes 2017-11-24 10:12:08 +00:00
Serge Schneider aa8731012e Round image size up to nearest 4M block 2017-11-24 10:12:08 +00:00
Serge Schneider 53259b48d3 Remove fonts-arkpandora 2017-11-24 07:10:45 +00:00
Serge Schneider 5c44fc727e stage2: install man-db 2017-11-24 07:10:45 +00:00
Andrew Wedgbury 35994f5d9c Remove /etc/vnc/updateid when finalising 2017-11-22 15:49:37 +00:00
XECDesign 31fcc80953 Fix typo in export-image
Fixes #132
2017-11-07 05:43:01 +00:00
XECDesign 90adfb1551 Label root partition
Fixes #131
2017-11-06 10:53:05 +00:00
Rick 9f2941954f Add caution about WORK_DIR filesystem 2017-09-28 13:40:58 +01:00
Claus Strasburger 52c6748e67 fix docker-in-docker copying when not doing CONTINUE=1 2017-09-21 15:06:11 +01:00
Claus Strasburger 732a87415d Docker-Build enhancements
- don't use any volume mounts anymore to allow using docker-in-docker
(with docker.sock mounted)
- smaller Docker build context by ignoring some files
2017-09-21 12:53:01 +01:00
Serge Schneider 9aa87dbfb4 Fix font packages 2017-09-21 12:45:05 +01:00
Jacen 26fcf59f3f [adding] qemu emulation layout to test images with qemu 2017-09-14 10:12:30 +01:00
Serge Schneider 496e41575e Revert "stage2: install fdisk"
This reverts commit e7e04fcde3.
2017-09-05 14:34:19 +01:00
Serge Schneider e7e04fcde3 stage2: install fdisk 2017-09-05 14:29:33 +01:00
Serge Schneider 5024709d70 Update release notes 2017-09-05 12:36:58 +01:00
Jacen 727db0ed63 [fixing] docker parts 2017-09-04 16:43:25 +01:00
Serge Schneider e64ea5bce4 stage3: install fonts-droid-fallback 2017-09-04 14:06:23 +01:00
Serge Schneider 63c312d1fe Update release notes 2017-09-04 12:17:49 +01:00
Serge Schneider 2f032b1d19 Update README.md
Fixes #105
2017-09-04 09:39:04 +01:00
Serge Schneider 05b31b287d Dockerfile: set DEBIAN_FRONTEND noninteractive 2017-08-31 11:27:33 +01:00
Serge Schneider b8c94731c5 stage1: fix symlink creation
Fixes #100
2017-08-31 11:24:01 +01:00
James Ruan c0513c547a export-image: when work in a non-English locale environment the PARTUUID will silently fail, resulting to an unbootable image file. (#96)
* use dd and xxd to get disk identifier

* add xxd as dependency
2017-08-31 11:22:33 +01:00
Serge Schneider dc0fb57fb9 stage2: install net-tools explicitly 2017-08-24 16:31:15 +01:00
Serge Schneider fcb8cca6ce NOOBS: bsdtar with --numeric-owner 2017-08-22 13:03:21 +01:00
Serge Schneider ce46fac1d4 Disable predictable network interface names 2017-08-21 10:15:50 +01:00
Russ K 3cc13f2aa2 Check for curl as a dependency for export-image (#95)
* Check for curl as a dependency for export-image

* Add curl to the Dockerfile
2017-08-21 09:48:55 +01:00
Serge Schneider 4dc1e1670e Update release notes 2017-08-17 14:46:35 +01:00
56 changed files with 473 additions and 280 deletions
+2
View File
@@ -1,3 +1,5 @@
output/ output/
work/ work/
deploy/ deploy/
apt-cacher-ng/
.git/objects/*
+1
View File
@@ -3,6 +3,7 @@ work/*
config config
postrun.sh postrun.sh
SKIP SKIP
SKIP_IMAGES
.pc .pc
*-pc *-pc
apt-cacher-ng/ apt-cacher-ng/
+3 -1
View File
@@ -1,10 +1,12 @@
FROM debian:stretch FROM debian:stretch
ENV DEBIAN_FRONTEND noninteractive
RUN apt-get -y update && \ RUN apt-get -y update && \
apt-get -y install \ apt-get -y install \
git vim parted \ git vim parted \
quilt realpath qemu-user-static debootstrap zerofree pxz zip dosfstools \ quilt realpath qemu-user-static debootstrap zerofree pxz zip dosfstools \
bsdtar libcap2-bin rsync grep udev xz-utils \ bsdtar libcap2-bin rsync grep udev xz-utils curl xxd \
&& rm -rf /var/lib/apt/lists/* && rm -rf /var/lib/apt/lists/*
COPY . /pi-gen/ COPY . /pi-gen/
+84 -8
View File
@@ -3,13 +3,13 @@
_Tool used to create the raspberrypi.org Raspbian images_ _Tool used to create the raspberrypi.org Raspbian images_
### TODO
1. Documentation
## Dependencies ## Dependencies
On Debian-based systems: pi-gen runs on Debian based operating systems. Currently it is only supported on
either Debian Stretch or Ubuntu Xenial and is known to have issues building on
earlier releases of these systems.
To install the required dependencies for pi-gen you should run:
```bash ```bash
apt-get install quilt parted realpath qemu-user-static debootstrap zerofree pxz zip \ apt-get install quilt parted realpath qemu-user-static debootstrap zerofree pxz zip \
@@ -62,10 +62,17 @@ The following environment variables are supported:
system for each build stage, amounting to tens of gigabytes in the case of system for each build stage, amounting to tens of gigabytes in the case of
Raspbian. Raspbian.
**CAUTION**: If your working directory is on an NTFS partition you probably won't be able to build. Make sure this is a proper Linux filesystem.
* `DEPLOY_DIR` (Default: `"$BASE_DIR/deploy"`) * `DEPLOY_DIR` (Default: `"$BASE_DIR/deploy"`)
Output directory for target system images and NOOBS bundles. Output directory for target system images and NOOBS bundles.
* `USE_QEMU` (Default: `"0"`)
Setting to '1' enables the QEMU mode - creating an image that can be mounted via QEMU for an emulated
environment. These images include "-qemu" in the image file name.
A simple example for building Raspbian: A simple example for building Raspbian:
@@ -74,6 +81,51 @@ IMG_NAME='Raspbian'
``` ```
## How the build process works
The following process is followed to build images:
* Loop through all of the stage directories in alphanumeric order
* Move on to the next directory if this stage directory contains a file called
"SKIP"
* Run the script ```prerun.sh``` which is generally just used to copy the build
directory between stages.
* In each stage directory loop through each subdirectory and then run each of the
install scripts it contains, again in alphanumeric order. These need to be named
with a two digit padded number at the beginning.
There are a number of different files and directories which can be used to
control different parts of the build process:
- **00-run.sh** - A unix shell script. Needs to be made executable for it to run.
- **00-run-chroot.sh** - A unix shell script which will be run in the chroot
of the image build directory. Needs to be made executable for it to run.
- **00-debconf** - Contents of this file are passed to debconf-set-selections
to configure things like locale, etc.
- **00-packages** - A list of packages to install. Can have more than one, space
separated, per line.
- **00-packages-nr** - As 00-packages, except these will be installed using
the ```--no-install-recommends -y``` parameters to apt-get.
- **00-patches** - A directory containing patch files to be applied, using quilt.
If a file named 'EDIT' is present in the directory, the build process will
be interrupted with a bash session, allowing an opportunity to create/revise
the patches.
* If the stage directory contains files called "EXPORT_NOOBS" or "EXPORT_IMAGE" then
add this stage to a list of images to generate
* Generate the images for any stages that have specified them
It is recommended to examine build.sh for finer details.
## Docker Build ## Docker Build
```bash ```bash
@@ -91,6 +143,12 @@ continue:
CONTINUE=1 ./build-docker.sh CONTINUE=1 ./build-docker.sh
``` ```
After successful build, the build container is by default removed. This may be undesired when making incremental changes to a customized build. To prevent the build script from remove the container add
```bash
PRESERVE_CONTAINER=1 ./build-docker.sh
```
There is a possibility that even when running from a docker container, the There is a possibility that even when running from a docker container, the
installation of `qemu-user-static` will silently fail when building the image installation of `qemu-user-static` will silently fail when building the image
because `binfmt-support` _must be enabled on the underlying kernel_. An easy because `binfmt-support` _must be enabled on the underlying kernel_. An easy
@@ -159,17 +217,35 @@ If you wish to build up to a specified stage (such as building up to stage 2
for a lite system), place an empty file named `SKIP` in each of the `./stage` for a lite system), place an empty file named `SKIP` in each of the `./stage`
directories you wish not to include. directories you wish not to include.
Then remove the `EXPORT*` files from `./stage4` (if building up to stage 2) or Then add an empty file named `SKIP_IMAGES` to `./stage4` (if building up to stage 2) or
from `./stage2` (if building a minimal system). to `./stage2` (if building a minimal system).
```bash ```bash
# Example for building a lite system # Example for building a lite system
echo "IMG_NAME='Raspbian'" > config echo "IMG_NAME='Raspbian'" > config
touch ./stage3/SKIP ./stage4/SKIP ./stage5/SKIP touch ./stage3/SKIP ./stage4/SKIP ./stage5/SKIP
rm stage4/EXPORT* touch ./stage4/SKIP_IMAGES ./stage5/SKIP_IMAGES
sudo ./build.sh # or ./build-docker.sh sudo ./build.sh # or ./build-docker.sh
``` ```
If you wish to build further configurations upon (for example) the lite If you wish to build further configurations upon (for example) the lite
system, you can also delete the contents of `./stage3` and `./stage4` and system, you can also delete the contents of `./stage3` and `./stage4` and
replace with your own contents in the same format. replace with your own contents in the same format.
## Skipping stages to speed up development
If you're working on a specific stage the recommended development process is as
follows:
* Add a file called SKIP_IMAGES into the directories containing EXPORT_* files
(currently stage2, stage4 and stage5)
* Add SKIP files to the stages you don't want to build. For example, if you're
basing your image on the lite image you would add these to stages 3, 4 and 5.
* Run build.sh to build all stages
* Add SKIP files to the earlier successfully built stages
* Modify the last stage
* Rebuild just the last stage using ```sudo CLEAN=1 ./build.sh```
* Once you're happy with the image you can remove the SKIP_IMAGES files and
export your image to test
+24 -15
View File
@@ -13,19 +13,19 @@ if ! $DOCKER ps >/dev/null; then
fi fi
set -e set -e
config_file=()
config_mount=()
if [ -f config ]; then if [ -f config ]; then
config_mount=("-v" "$(pwd)/config:/pi-gen/config:ro") config_file=("--env-file" "$(pwd)/config")
source config source config
fi fi
CONTAINER_NAME=${CONTAINER_NAME:-pigen_work} CONTAINER_NAME=${CONTAINER_NAME:-pigen_work}
CONTINUE=${CONTINUE:-0} CONTINUE=${CONTINUE:-0}
PRESERVE_CONTAINER=${PRESERVE_CONTAINER:-0}
if [ "$*" != "" ] || [ -z "${IMG_NAME}" ]; then if [ "$*" != "" ] || [ -z "${IMG_NAME}" ]; then
if [ -z "${IMG_NAME}" ]; then if [ -z "${IMG_NAME}" ]; then
echo "IMG_NAME not set in 'build'" 1>&2 echo "IMG_NAME not set in 'config'" 1>&2
echo 1>&2 echo 1>&2
fi fi
cat >&2 <<EOF cat >&2 <<EOF
@@ -33,7 +33,8 @@ Usage:
build-docker.sh [options] build-docker.sh [options]
Optional environment arguments: ( =<default> ) Optional environment arguments: ( =<default> )
CONTAINER_NAME=pigen_work set a name for the build container CONTAINER_NAME=pigen_work set a name for the build container
CONTINUE=0 continue from a previously started container CONTINUE=1 continue from a previously started container
PRESERVE_CONTAINER=1 keep build container even on successful build
EOF EOF
exit 1 exit 1
fi fi
@@ -47,31 +48,39 @@ fi
if [ "$CONTAINER_EXISTS" != "" ] && [ "$CONTINUE" != "1" ]; then if [ "$CONTAINER_EXISTS" != "" ] && [ "$CONTINUE" != "1" ]; then
echo "Container $CONTAINER_NAME already exists and you did not specify CONTINUE=1. Aborting." echo "Container $CONTAINER_NAME already exists and you did not specify CONTINUE=1. Aborting."
echo "You can delete the existing container like this:" echo "You can delete the existing container like this:"
echo " docker rm -v $CONTAINER_NAME" echo " $DOCKER rm -v $CONTAINER_NAME"
exit 1 exit 1
fi fi
$DOCKER build -t pi-gen . $DOCKER build -t pi-gen .
if [ "$CONTAINER_EXISTS" != "" ]; then if [ "$CONTAINER_EXISTS" != "" ]; then
trap "echo 'got CTRL+C... please wait 5s';docker stop -t 5 ${CONTAINER_NAME}_cont" SIGINT SIGTERM trap "echo 'got CTRL+C... please wait 5s'; $DOCKER stop -t 5 ${CONTAINER_NAME}_cont" SIGINT SIGTERM
time $DOCKER run --rm --privileged \ time $DOCKER run --rm --privileged \
--volumes-from="${CONTAINER_NAME}" --name "${CONTAINER_NAME}_cont" \ --volumes-from="${CONTAINER_NAME}" --name "${CONTAINER_NAME}_cont" \
-e IMG_NAME=${IMG_NAME}\ -e IMG_NAME="${IMG_NAME}"\
pi-gen \ pi-gen \
bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static && bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static &&
cd /pi-gen; ./build.sh; cd /pi-gen; ./build.sh;
rsync -av work/*/build.log deploy/" & rsync -av work/*/build.log deploy/" &
wait wait "$!"
else else
trap "echo 'got CTRL+C... please wait 5s'; docker stop -t 5 ${CONTAINER_NAME}" SIGINT SIGTERM trap "echo 'got CTRL+C... please wait 5s'; $DOCKER stop -t 5 ${CONTAINER_NAME}" SIGINT SIGTERM
$DOCKER run --name "${CONTAINER_NAME}" --privileged \ time $DOCKER run --name "${CONTAINER_NAME}" --privileged \
-e IMG_NAME=${IMG_NAME}\ -e IMG_NAME="${IMG_NAME}"\
-v "$(pwd)/deploy:/pi-gen/deploy" \ "${config_file[@]}" \
"${config_mount[@]}" \
pi-gen \ pi-gen \
bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static && bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static &&
cd /pi-gen; ./build.sh && cd /pi-gen; ./build.sh &&
rsync -av work/*/build.log deploy/" & rsync -av work/*/build.log deploy/" &
wait wait "$!"
fi fi
echo "copying results from deploy/"
$DOCKER cp "${CONTAINER_NAME}":/pi-gen/deploy .
ls -lah deploy
# cleanup
if [ "$PRESERVE_CONTAINER" != "1" ]; then
$DOCKER rm -v $CONTAINER_NAME
fi
echo "Done! Your image(s) should be in deploy/" echo "Done! Your image(s) should be in deploy/"
+57 -44
View File
@@ -1,22 +1,23 @@
#!/bin/bash -e #!/bin/bash -e
# shellcheck disable=SC2119,SC1091
run_sub_stage() run_sub_stage()
{ {
log "Begin ${SUB_STAGE_DIR}" log "Begin ${SUB_STAGE_DIR}"
pushd ${SUB_STAGE_DIR} > /dev/null pushd "${SUB_STAGE_DIR}" > /dev/null
for i in {00..99}; do for i in {00..99}; do
if [ -f ${i}-debconf ]; then if [ -f "${i}-debconf" ]; then
log "Begin ${SUB_STAGE_DIR}/${i}-debconf" log "Begin ${SUB_STAGE_DIR}/${i}-debconf"
on_chroot << EOF on_chroot << EOF
debconf-set-selections <<SELEOF debconf-set-selections <<SELEOF
`cat ${i}-debconf` $(cat "${i}-debconf")
SELEOF SELEOF
EOF EOF
log "End ${SUB_STAGE_DIR}/${i}-debconf" log "End ${SUB_STAGE_DIR}/${i}-debconf"
fi fi
if [ -f ${i}-packages-nr ]; then if [ -f "${i}-packages-nr" ]; then
log "Begin ${SUB_STAGE_DIR}/${i}-packages-nr" log "Begin ${SUB_STAGE_DIR}/${i}-packages-nr"
PACKAGES="$(sed -f "${SCRIPT_DIR}/remove-comments.sed" < ${i}-packages-nr)" PACKAGES="$(sed -f "${SCRIPT_DIR}/remove-comments.sed" < "${i}-packages-nr")"
if [ -n "$PACKAGES" ]; then if [ -n "$PACKAGES" ]; then
on_chroot << EOF on_chroot << EOF
apt-get install --no-install-recommends -y $PACKAGES apt-get install --no-install-recommends -y $PACKAGES
@@ -24,9 +25,9 @@ EOF
fi fi
log "End ${SUB_STAGE_DIR}/${i}-packages-nr" log "End ${SUB_STAGE_DIR}/${i}-packages-nr"
fi fi
if [ -f ${i}-packages ]; then if [ -f "${i}-packages" ]; then
log "Begin ${SUB_STAGE_DIR}/${i}-packages" log "Begin ${SUB_STAGE_DIR}/${i}-packages"
PACKAGES="$(sed -f "${SCRIPT_DIR}/remove-comments.sed" < ${i}-packages)" PACKAGES="$(sed -f "${SCRIPT_DIR}/remove-comments.sed" < "${i}-packages")"
if [ -n "$PACKAGES" ]; then if [ -n "$PACKAGES" ]; then
on_chroot << EOF on_chroot << EOF
apt-get install -y $PACKAGES apt-get install -y $PACKAGES
@@ -34,18 +35,18 @@ EOF
fi fi
log "End ${SUB_STAGE_DIR}/${i}-packages" log "End ${SUB_STAGE_DIR}/${i}-packages"
fi fi
if [ -d ${i}-patches ]; then if [ -d "${i}-patches" ]; then
log "Begin ${SUB_STAGE_DIR}/${i}-patches" log "Begin ${SUB_STAGE_DIR}/${i}-patches"
pushd ${STAGE_WORK_DIR} > /dev/null pushd "${STAGE_WORK_DIR}" > /dev/null
if [ "${CLEAN}" = "1" ]; then if [ "${CLEAN}" = "1" ]; then
rm -rf .pc rm -rf .pc
rm -rf *-pc rm -rf ./*-pc
fi fi
QUILT_PATCHES=${SUB_STAGE_DIR}/${i}-patches QUILT_PATCHES="${SUB_STAGE_DIR}/${i}-patches"
SUB_STAGE_QUILT_PATCH_DIR="$(basename $SUB_STAGE_DIR)-pc" SUB_STAGE_QUILT_PATCH_DIR="$(basename "$SUB_STAGE_DIR")-pc"
mkdir -p $SUB_STAGE_QUILT_PATCH_DIR mkdir -p "$SUB_STAGE_QUILT_PATCH_DIR"
ln -snf $SUB_STAGE_QUILT_PATCH_DIR .pc ln -snf "$SUB_STAGE_QUILT_PATCH_DIR" .pc
if [ -e ${SUB_STAGE_DIR}/${i}-patches/EDIT ]; then if [ -e "${SUB_STAGE_DIR}/${i}-patches/EDIT" ]; then
echo "Dropping into bash to edit patches..." echo "Dropping into bash to edit patches..."
bash bash
fi fi
@@ -80,18 +81,20 @@ EOF
run_stage(){ run_stage(){
log "Begin ${STAGE_DIR}" log "Begin ${STAGE_DIR}"
STAGE=$(basename ${STAGE_DIR}) STAGE="$(basename "${STAGE_DIR}")"
pushd ${STAGE_DIR} > /dev/null pushd "${STAGE_DIR}" > /dev/null
unmount ${WORK_DIR}/${STAGE} unmount "${WORK_DIR}/${STAGE}"
STAGE_WORK_DIR=${WORK_DIR}/${STAGE} STAGE_WORK_DIR="${WORK_DIR}/${STAGE}"
ROOTFS_DIR=${STAGE_WORK_DIR}/rootfs ROOTFS_DIR="${STAGE_WORK_DIR}"/rootfs
if [ -f ${STAGE_DIR}/EXPORT_IMAGE ]; then if [ ! -f SKIP_IMAGES ]; then
EXPORT_DIRS="${EXPORT_DIRS} ${STAGE_DIR}" if [ -f "${STAGE_DIR}/EXPORT_IMAGE" ]; then
EXPORT_DIRS="${EXPORT_DIRS} ${STAGE_DIR}"
fi
fi fi
if [ ! -f SKIP ]; then if [ ! -f SKIP ]; then
if [ "${CLEAN}" = "1" ]; then if [ "${CLEAN}" = "1" ]; then
if [ -d ${ROOTFS_DIR} ]; then if [ -d "${ROOTFS_DIR}" ]; then
rm -rf ${ROOTFS_DIR} rm -rf "${ROOTFS_DIR}"
fi fi
fi fi
if [ -x prerun.sh ]; then if [ -x prerun.sh ]; then
@@ -100,16 +103,16 @@ run_stage(){
log "End ${STAGE_DIR}/prerun.sh" log "End ${STAGE_DIR}/prerun.sh"
fi fi
for SUB_STAGE_DIR in ${STAGE_DIR}/*; do for SUB_STAGE_DIR in ${STAGE_DIR}/*; do
if [ -d ${SUB_STAGE_DIR} ] && if [ -d "${SUB_STAGE_DIR}" ] &&
[ ! -f ${SUB_STAGE_DIR}/SKIP ]; then [ ! -f "${SUB_STAGE_DIR}/SKIP" ]; then
run_sub_stage run_sub_stage
fi fi
done done
fi fi
unmount ${WORK_DIR}/${STAGE} unmount "${WORK_DIR}/${STAGE}"
PREV_STAGE=${STAGE} PREV_STAGE="${STAGE}"
PREV_STAGE_DIR=${STAGE_DIR} PREV_STAGE_DIR="${STAGE_DIR}"
PREV_ROOTFS_DIR=${ROOTFS_DIR} PREV_ROOTFS_DIR="${ROOTFS_DIR}"
popd > /dev/null popd > /dev/null
log "End ${STAGE_DIR}" log "End ${STAGE_DIR}"
} }
@@ -119,6 +122,7 @@ if [ "$(id -u)" != "0" ]; then
exit 1 exit 1
fi fi
if [ -f config ]; then if [ -f config ]; then
source config source config
fi fi
@@ -128,14 +132,17 @@ if [ -z "${IMG_NAME}" ]; then
exit 1 exit 1
fi fi
export IMG_DATE=${IMG_DATE:-"$(date +%Y-%m-%d)"} export USE_QEMU="${USE_QEMU:-0}"
export IMG_DATE="${IMG_DATE:-"$(date +%Y-%m-%d)"}"
export BASE_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)" BASE_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
export SCRIPT_DIR="${BASE_DIR}/scripts" export SCRIPT_DIR="${BASE_DIR}/scripts"
export WORK_DIR=${WORK_DIR:-"${BASE_DIR}/work/${IMG_DATE}-${IMG_NAME}"} export WORK_DIR="${WORK_DIR:-"${BASE_DIR}/work/${IMG_DATE}-${IMG_NAME}"}"
export DEPLOY_DIR=${DEPLOY_DIR:-"${BASE_DIR}/deploy"} export DEPLOY_DIR=${DEPLOY_DIR:-"${BASE_DIR}/deploy"}
export LOG_FILE="${WORK_DIR}/build.log" export LOG_FILE="${WORK_DIR}/build.log"
export BASE_DIR
export CLEAN export CLEAN
export IMG_NAME export IMG_NAME
export APT_PROXY export APT_PROXY
@@ -158,29 +165,35 @@ export QUILT_NO_DIFF_INDEX=1
export QUILT_NO_DIFF_TIMESTAMPS=1 export QUILT_NO_DIFF_TIMESTAMPS=1
export QUILT_REFRESH_ARGS="-p ab" export QUILT_REFRESH_ARGS="-p ab"
source ${SCRIPT_DIR}/common # shellcheck source=scripts/common
source ${SCRIPT_DIR}/dependencies_check source "${SCRIPT_DIR}/common"
# shellcheck source=scripts/dependencies_check
source "${SCRIPT_DIR}/dependencies_check"
dependencies_check ${BASE_DIR}/depends dependencies_check "${BASE_DIR}/depends"
mkdir -p ${WORK_DIR} mkdir -p "${WORK_DIR}"
log "Begin ${BASE_DIR}" log "Begin ${BASE_DIR}"
for STAGE_DIR in ${BASE_DIR}/stage*; do for STAGE_DIR in "${BASE_DIR}/stage"*; do
run_stage run_stage
done done
CLEAN=1 CLEAN=1
for EXPORT_DIR in ${EXPORT_DIRS}; do for EXPORT_DIR in ${EXPORT_DIRS}; do
STAGE_DIR=${BASE_DIR}/export-image STAGE_DIR=${BASE_DIR}/export-image
# shellcheck source=/dev/null
source "${EXPORT_DIR}/EXPORT_IMAGE" source "${EXPORT_DIR}/EXPORT_IMAGE"
EXPORT_ROOTFS_DIR=${WORK_DIR}/$(basename ${EXPORT_DIR})/rootfs EXPORT_ROOTFS_DIR=${WORK_DIR}/$(basename "${EXPORT_DIR}")/rootfs
run_stage run_stage
if [ -e ${EXPORT_DIR}/EXPORT_NOOBS ]; then if [ "${USE_QEMU}" != "1" ]; then
source ${EXPORT_DIR}/EXPORT_NOOBS if [ -e "${EXPORT_DIR}/EXPORT_NOOBS" ]; then
STAGE_DIR=${BASE_DIR}/export-noobs # shellcheck source=/dev/null
run_stage source "${EXPORT_DIR}/EXPORT_NOOBS"
STAGE_DIR="${BASE_DIR}/export-noobs"
run_stage
fi
fi fi
done done
+2
View File
@@ -11,3 +11,5 @@ bsdtar
grep grep
rsync rsync
xz:xz-utils xz:xz-utils
curl
xxd
+2 -10
View File
@@ -1,13 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ -e ${ROOTFS_DIR}/etc/ld.so.preload ]; then if [ ! -x "${ROOTFS_DIR}/usr/bin/qemu-arm-static" ]; then
mv ${ROOTFS_DIR}/etc/ld.so.preload ${ROOTFS_DIR}/etc/ld.so.preload.disabled cp /usr/bin/qemu-arm-static "${ROOTFS_DIR}/usr/bin/"
fi
if [ ! -e ${ROOTFS_DIR}/usr/sbin/policy-rc.d ]; then
install -m 744 files/policy-rc.d ${ROOTFS_DIR}/usr/sbin/
fi
if [ ! -x ${ROOTFS_DIR}/usr/bin/qemu-arm-static ]; then
cp /usr/bin/qemu-arm-static ${ROOTFS_DIR}/usr/bin/
fi fi
@@ -1,3 +0,0 @@
#!/bin/sh
exit 101
+1 -1
View File
@@ -1,3 +1,3 @@
#!/bin/bash -e #!/bin/bash -e
install -m 644 files/resolv.conf ${ROOTFS_DIR}/etc/ install -m 644 files/resolv.conf "${ROOTFS_DIR}/etc/"
+4 -4
View File
@@ -2,12 +2,12 @@
IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img"
IMGID="$(fdisk -l ${IMG_FILE} | sed -n 's/Disk identifier: 0x\([^ ]*\)/\1/p')" IMGID="$(dd if="${IMG_FILE}" skip=440 bs=1 count=4 2>/dev/null | xxd -e | cut -f 2 -d' ')"
BOOT_PARTUUID="${IMGID}-01" BOOT_PARTUUID="${IMGID}-01"
ROOT_PARTUUID="${IMGID}-02" ROOT_PARTUUID="${IMGID}-02"
sed -i "s/BOOTDEV/PARTUUID=${BOOT_PARTUUID}/" ${ROOTFS_DIR}/etc/fstab sed -i "s/BOOTDEV/PARTUUID=${BOOT_PARTUUID}/" "${ROOTFS_DIR}/etc/fstab"
sed -i "s/ROOTDEV/PARTUUID=${ROOT_PARTUUID}/" ${ROOTFS_DIR}/etc/fstab sed -i "s/ROOTDEV/PARTUUID=${ROOT_PARTUUID}/" "${ROOTFS_DIR}/etc/fstab"
sed -i "s/ROOTDEV/PARTUUID=${ROOT_PARTUUID}/" ${ROOTFS_DIR}/boot/cmdline.txt sed -i "s/ROOTDEV/PARTUUID=${ROOT_PARTUUID}/" "${ROOTFS_DIR}/boot/cmdline.txt"
+44 -44
View File
@@ -8,77 +8,77 @@ on_chroot << EOF
hardlink -t /usr/share/doc hardlink -t /usr/share/doc
EOF EOF
if [ -d ${ROOTFS_DIR}/home/pi/.config ]; then if [ -d "${ROOTFS_DIR}/home/pi/.config" ]; then
chmod 700 ${ROOTFS_DIR}/home/pi/.config chmod 700 "${ROOTFS_DIR}/home/pi/.config"
fi fi
rm -f ${ROOTFS_DIR}/etc/apt/apt.conf.d/51cache rm -f "${ROOTFS_DIR}/etc/apt/apt.conf.d/51cache"
rm -f ${ROOTFS_DIR}/usr/sbin/policy-rc.d rm -f "${ROOTFS_DIR}/usr/bin/qemu-arm-static"
rm -f ${ROOTFS_DIR}/usr/bin/qemu-arm-static
if [ -e ${ROOTFS_DIR}/etc/ld.so.preload.disabled ]; then
mv ${ROOTFS_DIR}/etc/ld.so.preload.disabled ${ROOTFS_DIR}/etc/ld.so.preload
fi
rm -f ${ROOTFS_DIR}/etc/apt/sources.list~ rm -f "${ROOTFS_DIR}/etc/apt/sources.list~"
rm -f ${ROOTFS_DIR}/etc/apt/trusted.gpg~ rm -f "${ROOTFS_DIR}/etc/apt/trusted.gpg~"
rm -f ${ROOTFS_DIR}/etc/passwd- rm -f "${ROOTFS_DIR}/etc/passwd-"
rm -f ${ROOTFS_DIR}/etc/group- rm -f "${ROOTFS_DIR}/etc/group-"
rm -f ${ROOTFS_DIR}/etc/shadow- rm -f "${ROOTFS_DIR}/etc/shadow-"
rm -f ${ROOTFS_DIR}/etc/gshadow- rm -f "${ROOTFS_DIR}/etc/gshadow-"
rm -f "${ROOTFS_DIR}/etc/subuid-"
rm -f "${ROOTFS_DIR}/etc/subgid-"
rm -f ${ROOTFS_DIR}/var/cache/debconf/*-old rm -f "${ROOTFS_DIR}"/var/cache/debconf/*-old
rm -f ${ROOTFS_DIR}/var/lib/dpkg/*-old rm -f "${ROOTFS_DIR}"/var/lib/dpkg/*-old
rm -f ${ROOTFS_DIR}/usr/share/icons/*/icon-theme.cache rm -f "${ROOTFS_DIR}"/usr/share/icons/*/icon-theme.cache
rm -f ${ROOTFS_DIR}/var/lib/dbus/machine-id rm -f "${ROOTFS_DIR}/var/lib/dbus/machine-id"
true > ${ROOTFS_DIR}/etc/machine-id true > "${ROOTFS_DIR}/etc/machine-id"
ln -nsf /proc/mounts ${ROOTFS_DIR}/etc/mtab ln -nsf /proc/mounts "${ROOTFS_DIR}/etc/mtab"
for _FILE in $(find ${ROOTFS_DIR}/var/log/ -type f); do find "${ROOTFS_DIR}/var/log/" -type f -exec cp /dev/null {} \;
true > ${_FILE}
done
rm -f "${ROOTFS_DIR}/root/.vnc/private.key" rm -f "${ROOTFS_DIR}/root/.vnc/private.key"
rm -f "${ROOTFS_DIR}/etc/vnc/updateid"
update_issue $(basename ${EXPORT_DIR}) update_issue "$(basename "${EXPORT_DIR}")"
install -m 644 ${ROOTFS_DIR}/etc/rpi-issue ${ROOTFS_DIR}/boot/issue.txt install -m 644 "${ROOTFS_DIR}/etc/rpi-issue" "${ROOTFS_DIR}/boot/issue.txt"
install files/LICENSE.oracle ${ROOTFS_DIR}/boot/ install files/LICENSE.oracle "${ROOTFS_DIR}/boot/"
cp "$ROOTFS_DIR/etc/rpi-issue" "$INFO_FILE" cp "$ROOTFS_DIR/etc/rpi-issue" "$INFO_FILE"
firmware=$(zgrep "firmware as of" "$ROOTFS_DIR/usr/share/doc/raspberrypi-kernel/changelog.Debian.gz" | \
head -n1 | \
sed -n 's|.* \([^ ]*\)$|\1|p')
printf "\nFirmware: https://github.com/raspberrypi/firmware/tree/%s\n" "$firmware" >> "$INFO_FILE" {
firmware=$(zgrep "firmware as of" \
"$ROOTFS_DIR/usr/share/doc/raspberrypi-kernel/changelog.Debian.gz" | \
head -n1 | sed -n 's|.* \([^ ]*\)$|\1|p')
printf "\nFirmware: https://github.com/raspberrypi/firmware/tree/%s\n" "$firmware"
kernel=$(curl -s -L "https://github.com/raspberrypi/firmware/raw/$firmware/extra/git_hash") kernel="$(curl -s -L "https://github.com/raspberrypi/firmware/raw/$firmware/extra/git_hash")"
printf "Kernel: https://github.com/raspberrypi/linux/tree/%s\n" "$kernel" >> "$INFO_FILE" printf "Kernel: https://github.com/raspberrypi/linux/tree/%s\n" "$kernel"
uname=$(curl -s -L "https://github.com/raspberrypi/firmware/raw/$firmware/extra/uname_string7") uname="$(curl -s -L "https://github.com/raspberrypi/firmware/raw/$firmware/extra/uname_string7")"
printf "Uname string: %s\n" "$uname" >> "$INFO_FILE"
printf "\nPackages:\n">> "$INFO_FILE" printf "Uname string: %s\n" "$uname"
dpkg -l --root "$ROOTFS_DIR" >> "$INFO_FILE" printf "\nPackages:\n"
dpkg -l --root "$ROOTFS_DIR"
} >> "$INFO_FILE"
ROOT_DEV=$(mount | grep "${ROOTFS_DIR} " | cut -f1 -d' ') ROOT_DEV="$(mount | grep "${ROOTFS_DIR} " | cut -f1 -d' ')"
unmount ${ROOTFS_DIR} unmount "${ROOTFS_DIR}"
zerofree -v ${ROOT_DEV} zerofree -v "${ROOT_DEV}"
unmount_image ${IMG_FILE} unmount_image "${IMG_FILE}"
mkdir -p ${DEPLOY_DIR} mkdir -p "${DEPLOY_DIR}"
rm -f ${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip rm -f "${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip"
pushd ${STAGE_WORK_DIR} > /dev/null pushd "${STAGE_WORK_DIR}" > /dev/null
zip ${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip $(basename ${IMG_FILE}) zip "${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip" \
"$(basename "${IMG_FILE}")"
popd > /dev/null popd > /dev/null
cp "$INFO_FILE" "$DEPLOY_DIR" cp "$INFO_FILE" "$DEPLOY_DIR"
+21 -19
View File
@@ -2,20 +2,22 @@
IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img"
unmount_image ${IMG_FILE} unmount_image "${IMG_FILE}"
rm -f ${IMG_FILE} rm -f "${IMG_FILE}"
rm -rf ${ROOTFS_DIR} rm -rf "${ROOTFS_DIR}"
mkdir -p ${ROOTFS_DIR} mkdir -p "${ROOTFS_DIR}"
BOOT_SIZE=$(du --apparent-size -s ${EXPORT_ROOTFS_DIR}/boot --block-size=1 | cut -f 1) BOOT_SIZE=$(du --apparent-size -s "${EXPORT_ROOTFS_DIR}/boot" --block-size=1 | cut -f 1)
TOTAL_SIZE=$(du --apparent-size -s ${EXPORT_ROOTFS_DIR} --exclude var/cache/apt/archives --block-size=1 | cut -f 1) TOTAL_SIZE=$(du --apparent-size -s "${EXPORT_ROOTFS_DIR}" --exclude var/cache/apt/archives --block-size=1 | cut -f 1)
IMG_SIZE=$((BOOT_SIZE + TOTAL_SIZE + (800 * 1024 * 1024))) ROUND_SIZE="$((4 * 1024 * 1024))"
ROUNDED_ROOT_SECTOR=$(((2 * BOOT_SIZE + ROUND_SIZE) / ROUND_SIZE * ROUND_SIZE / 512 + 8192))
IMG_SIZE=$(((BOOT_SIZE + TOTAL_SIZE + (800 * 1024 * 1024) + ROUND_SIZE - 1) / ROUND_SIZE * ROUND_SIZE))
truncate -s ${IMG_SIZE} ${IMG_FILE} truncate -s "${IMG_SIZE}" "${IMG_FILE}"
fdisk -H 255 -S 63 ${IMG_FILE} <<EOF fdisk -H 255 -S 63 "${IMG_FILE}" <<EOF
o o
n n
@@ -28,14 +30,14 @@ c
n n
8192 ${ROUNDED_ROOT_SECTOR}
p p
w w
EOF EOF
PARTED_OUT=$(parted -s ${IMG_FILE} unit b print) PARTED_OUT=$(parted -s "${IMG_FILE}" unit b print)
BOOT_OFFSET=$(echo "$PARTED_OUT" | grep -e '^ 1'| xargs echo -n \ BOOT_OFFSET=$(echo "$PARTED_OUT" | grep -e '^ 1'| xargs echo -n \
| cut -d" " -f 2 | tr -d B) | cut -d" " -f 2 | tr -d B)
BOOT_LENGTH=$(echo "$PARTED_OUT" | grep -e '^ 1'| xargs echo -n \ BOOT_LENGTH=$(echo "$PARTED_OUT" | grep -e '^ 1'| xargs echo -n \
@@ -46,8 +48,8 @@ ROOT_OFFSET=$(echo "$PARTED_OUT" | grep -e '^ 2'| xargs echo -n \
ROOT_LENGTH=$(echo "$PARTED_OUT" | grep -e '^ 2'| xargs echo -n \ ROOT_LENGTH=$(echo "$PARTED_OUT" | grep -e '^ 2'| xargs echo -n \
| cut -d" " -f 4 | tr -d B) | cut -d" " -f 4 | tr -d B)
BOOT_DEV=$(losetup --show -f -o ${BOOT_OFFSET} --sizelimit ${BOOT_LENGTH} ${IMG_FILE}) BOOT_DEV=$(losetup --show -f -o "${BOOT_OFFSET}" --sizelimit "${BOOT_LENGTH}" "${IMG_FILE}")
ROOT_DEV=$(losetup --show -f -o ${ROOT_OFFSET} --sizelimit ${ROOT_LENGTH} ${IMG_FILE}) ROOT_DEV=$(losetup --show -f -o "${ROOT_OFFSET}" --sizelimit "${ROOT_LENGTH}" "${IMG_FILE}")
echo "/boot: offset $BOOT_OFFSET, length $BOOT_LENGTH" echo "/boot: offset $BOOT_OFFSET, length $BOOT_LENGTH"
echo "/: offset $ROOT_OFFSET, length $ROOT_LENGTH" echo "/: offset $ROOT_OFFSET, length $ROOT_LENGTH"
@@ -57,11 +59,11 @@ for FEATURE in metadata_csum 64bit; do
ROOT_FEATURES="^$FEATURE,$ROOT_FEATURES" ROOT_FEATURES="^$FEATURE,$ROOT_FEATURES"
fi fi
done done
mkdosfs -n boot -F 32 -v $BOOT_DEV > /dev/null mkdosfs -n boot -F 32 -v "$BOOT_DEV" > /dev/null
mkfs.ext4 -O $ROOT_FEATURES $ROOT_DEV > /dev/null mkfs.ext4 -L rootfs -O "$ROOT_FEATURES" "$ROOT_DEV" > /dev/null
mount -v $ROOT_DEV ${ROOTFS_DIR} -t ext4 mount -v "$ROOT_DEV" "${ROOTFS_DIR}" -t ext4
mkdir -p ${ROOTFS_DIR}/boot mkdir -p "${ROOTFS_DIR}/boot"
mount -v $BOOT_DEV ${ROOTFS_DIR}/boot -t vfat mount -v "$BOOT_DEV" "${ROOTFS_DIR}/boot" -t vfat
rsync -aHAXx --exclude var/cache/apt/archives ${EXPORT_ROOTFS_DIR}/ ${ROOTFS_DIR}/ rsync -aHAXx --exclude var/cache/apt/archives "${EXPORT_ROOTFS_DIR}/" "${ROOTFS_DIR}/"
+22 -22
View File
@@ -2,35 +2,35 @@
NOOBS_DIR="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}" NOOBS_DIR="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}"
install -v -m 744 files/partition_setup.sh ${NOOBS_DIR}/ install -v -m 744 files/partition_setup.sh "${NOOBS_DIR}/"
install -v files/partitions.json ${NOOBS_DIR}/ install -v files/partitions.json "${NOOBS_DIR}/"
install -v files/os.json ${NOOBS_DIR}/ install -v files/os.json "${NOOBS_DIR}/"
install -v files/OS.png ${NOOBS_DIR}/ install -v files/OS.png "${NOOBS_DIR}/"
install -v files/release_notes.txt ${NOOBS_DIR}/ install -v files/release_notes.txt "${NOOBS_DIR}/"
tar -v -c -C files/marketing -f ${NOOBS_DIR}/marketing.tar . tar -v -c -C files/marketing -f "${NOOBS_DIR}/marketing.tar" .
BOOT_SIZE=$(xz --robot -l ${NOOBS_DIR}/boot.tar.xz | grep totals | cut -f 5) BOOT_SIZE="$(xz --robot -l "${NOOBS_DIR}/boot.tar.xz" | grep totals | cut -f 5)"
ROOT_SIZE=$(xz --robot -l ${NOOBS_DIR}/root.tar.xz | grep totals | cut -f 5) ROOT_SIZE="$(xz --robot -l "${NOOBS_DIR}/root.tar.xz" | grep totals | cut -f 5)"
BOOT_SIZE=$(expr ${BOOT_SIZE} / 1000000 \+ 1) BOOT_SIZE="$(( BOOT_SIZE / 1000000 + 1))"
ROOT_SIZE=$(expr ${ROOT_SIZE} / 1000000 \+ 1) ROOT_SIZE="$(( ROOT_SIZE / 1000000 + 1))"
BOOT_NOM=$(expr ${BOOT_SIZE} \* 3) BOOT_NOM="$(( BOOT_SIZE * 3 ))"
ROOT_NOM=$(expr ${ROOT_SIZE} \+ 400) ROOT_NOM="$(( ROOT_SIZE + 400 ))"
mv "${NOOBS_DIR}/OS.png" "${NOOBS_DIR}/$(echo ${NOOBS_NAME} | sed 's/ /_/g').png" mv "${NOOBS_DIR}/OS.png" "${NOOBS_DIR}/${NOOBS_NAME// /_}.png"
sed ${NOOBS_DIR}/partitions.json -i -e "s|BOOT_SIZE|${BOOT_SIZE}|" sed "${NOOBS_DIR}/partitions.json" -i -e "s|BOOT_SIZE|${BOOT_SIZE}|"
sed ${NOOBS_DIR}/partitions.json -i -e "s|ROOT_SIZE|${ROOT_SIZE}|" sed "${NOOBS_DIR}/partitions.json" -i -e "s|ROOT_SIZE|${ROOT_SIZE}|"
sed ${NOOBS_DIR}/partitions.json -i -e "s|BOOT_NOM|${BOOT_NOM}|" sed "${NOOBS_DIR}/partitions.json" -i -e "s|BOOT_NOM|${BOOT_NOM}|"
sed ${NOOBS_DIR}/partitions.json -i -e "s|ROOT_NOM|${ROOT_NOM}|" sed "${NOOBS_DIR}/partitions.json" -i -e "s|ROOT_NOM|${ROOT_NOM}|"
sed ${NOOBS_DIR}/os.json -i -e "s|UNRELEASED|${IMG_DATE}|" sed "${NOOBS_DIR}/os.json" -i -e "s|UNRELEASED|${IMG_DATE}|"
sed ${NOOBS_DIR}/os.json -i -e "s|NOOBS_NAME|${NOOBS_NAME}|" sed "${NOOBS_DIR}/os.json" -i -e "s|NOOBS_NAME|${NOOBS_NAME}|"
sed ${NOOBS_DIR}/os.json -i -e "s|NOOBS_DESCRIPTION|${NOOBS_DESCRIPTION}|" sed "${NOOBS_DIR}/os.json" -i -e "s|NOOBS_DESCRIPTION|${NOOBS_DESCRIPTION}|"
sed ${NOOBS_DIR}/release_notes.txt -i -e "s|UNRELEASED|${IMG_DATE}|" sed "${NOOBS_DIR}/release_notes.txt" -i -e "s|UNRELEASED|${IMG_DATE}|"
cp -a ${NOOBS_DIR} ${DEPLOY_DIR}/ cp -a "${NOOBS_DIR}" "${DEPLOY_DIR}/"
+3 -2
View File
@@ -1,7 +1,7 @@
{ {
"description": "NOOBS_DESCRIPTION", "description": "NOOBS_DESCRIPTION",
"feature_level": 35120124, "feature_level": 35120124,
"kernel": "4.9", "kernel": "4.14",
"name": "NOOBS_NAME", "name": "NOOBS_NAME",
"password": "raspberry", "password": "raspberry",
"release_date": "UNRELEASED", "release_date": "UNRELEASED",
@@ -10,7 +10,8 @@
"Pi Model", "Pi Model",
"Pi 2", "Pi 2",
"Pi Zero", "Pi Zero",
"Pi 3" "Pi 3",
"Pi Compute Module 3"
], ],
"url": "http://www.raspbian.org/", "url": "http://www.raspbian.org/",
"username": "pi", "username": "pi",
@@ -1,4 +1,84 @@
UNRELEASED: UNRELEASED:
* New first-boot configuration wizard added
* Recommended Software installer added
* Bluej, Greenfoot, NodeRED, Claws Mail, VNC Viewer removed from image - can now be installed from Recommended Applications
* Qpdfview PDF viewer installed instead of Xpdf
* Version 65.0 of Chromium browser included, with latest Flash player
* Volume up / down keys now change by 5% increments and affect currently-selected output device rather than internal device only
* Network plugin now remembers previously-entered WiFi network passwords when prompting for reconnection
* Serial port and serial console can now be switched separately in Raspberry Pi Configuration
* Lxkeymap keyboard language setting application removed - replaced with dialog within Raspberry Pi Configuration
* Wifi country and keyboard language setting dialogs in Raspberry Pi Configuration now callable from other applications
* New version of Piboto font included to render with correct weight under some rogue applications
* Reconnection to Bluetooth audio devices on reboot improved
* Disable click-to-rename behaviour in file manager if single-click selection enabled
* Appearance Settings dialog makes config changes to some Qt files to match selected theme
* MIME file type associations improved
* Multiple desktop management options removed from mouse middle-click menu
* Menu shortcuts to Raspberry Pi website amended
* Python 2 IDLE menu link removed
* Sample Magpi PDF installed in /home/pi/MagPi
* Various minor tweaks, bug fixes and appearance changes
* Bluetooth updates
- Firmware with Bluetooth 4.2 features
- SCO profile suppot added via bthelper.service
* Linux kernel 4.14.50+
* Raspberry Pi firmware 748fb17992426bb29d99224b93cb962fefbdc833
2018-08-14:
* Fixed race between wifi-country.service and raspberrypi-net-mods.service
* Linux kernel 4.14.34+
* Raspberry Pi firmware 5db8e4e1c63178e200d6fbea23ed4a9bf4656658
2018-03-13:
* Raspberry Pi 3 B+ support
* WiFi is disabled until wireless regulatory domain is set (Pi 3 B+ only)
- The domain can be done through 'Raspberry Pi Configuration' (rc_gui),
'raspi-config' or by setting 'country=' to an appropriate ISO 3166
alpha2 country code in /etc/wpa_supplicant/wpa_supplicant.conf.
* Default wireless regulatory domain is now unset
* Added support to desktop for different screen sizes and resolutions,
including multiple preset options in Appearance Settings and pixel doubling
option in Raspberry Pi Configuration
* Version 2.1.16 of Thonny included
* Version 29.0.0.113 of Adobe PepperFlash player included
* Version 1.2.post1 of Pygame Zero included
* Bluetooth plugin now supports connection to Bluetooth LE HID devices
* Network plugin now indicates 5G-compatible APs
* Latest changes to Bluez ALSA service merged
- service now started on CLI boot as well as GUI boot
* Latest changes to dhcpcd networking plugin merged
* Improved support for running on pi-top devices
* Small design changes to PiX theme and icons
* Bug fix - hide spurious window resize handles
* Bug fix - Scratch 2 remote GPIO state block now works correctly
* Updated WiFi Firmware
- brcmfmac43455-sdio 7.45.154
- brcmfmac43430-sdio 7.45.98.38
* New packages:
- policykit-1
- obconf
- python-buttonshim python3-buttonshim
- python-unicornhathd python3-unicornhathd
- python-pantilthat python3-pantilthat
* Linux kernel 4.9.80+
* Raspberry Pi firmware 3347884c7df574bbabeff6dca63caf686e629699
2017-11-29:
* Added battery monitor plugin for taskbar - works on x86 images or first-generation Pi-Top
* Added cutdown mode to PCManFM file manager to reduce complexity
* Added ability to rename files in PCManFM by clicking name when selected
* Bug fix in Bluetooth ALSA module to reduce truncation of audio at end of playback
* Various small tweaks, bug fixes and theme modifications
* New kernel and firmware
2017-09-07:
* Disable predictable network interface names for Ethernet devices
* Bug fix for keyboard settings dialog in Raspberry Pi Configuration
* Bug fix for crash on some videos and animations in Chromium
* Bug fix for taskbar crash when running RealVNC server
* Bug fix for reloading projects with extensions in Scratch 2
* Bug fix for MAC address problem in Bluetooth
* Simple mode and new icons in Thonny
* New Japanese translations in Raspberry Pi Configuration
* Install fonts-droid-fallback for international fonts
2017-08-16:
* Based on Raspbian Stretch (Debian version 9) * Based on Raspbian Stretch (Debian version 9)
* Version 60 of Chromium browser included * Version 60 of Chromium browser included
* Version 3.0.1 of Sonic Pi included * Version 3.0.1 of Sonic Pi included
@@ -9,6 +89,7 @@ UNRELEASED:
* Various desktop applications modified to prompt for sudo password if needed * Various desktop applications modified to prompt for sudo password if needed
* lxinput control options for mouse speed simplified * lxinput control options for mouse speed simplified
* lxpanel plugins moved into separate packages * lxpanel plugins moved into separate packages
* Wireless firmware for Pi 3 and Pi 0W modified to address Broadpwn exploit
* Latest kernel and firmware * Latest kernel and firmware
* Various small tweaks, bug fixes and theme modifications * Various small tweaks, bug fixes and theme modifications
2017-07-05: 2017-07-05:
+15 -15
View File
@@ -2,14 +2,14 @@
IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img"
NOOBS_DIR="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}" NOOBS_DIR="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}"
unmount_image ${IMG_FILE} unmount_image "${IMG_FILE}"
mkdir -p ${STAGE_WORK_DIR} mkdir -p "${STAGE_WORK_DIR}"
cp ${WORK_DIR}/export-image/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img ${STAGE_WORK_DIR}/ cp "${WORK_DIR}/export-image/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" "${STAGE_WORK_DIR}/"
rm -rf ${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX} rm -rf "${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}"
PARTED_OUT=$(parted -s ${IMG_FILE} unit b print) PARTED_OUT=$(parted -s "${IMG_FILE}" unit b print)
BOOT_OFFSET=$(echo "$PARTED_OUT" | grep -e '^ 1'| xargs echo -n \ BOOT_OFFSET=$(echo "$PARTED_OUT" | grep -e '^ 1'| xargs echo -n \
| cut -d" " -f 2 | tr -d B) | cut -d" " -f 2 | tr -d B)
BOOT_LENGTH=$(echo "$PARTED_OUT" | grep -e '^ 1'| xargs echo -n \ BOOT_LENGTH=$(echo "$PARTED_OUT" | grep -e '^ 1'| xargs echo -n \
@@ -20,21 +20,21 @@ ROOT_OFFSET=$(echo "$PARTED_OUT" | grep -e '^ 2'| xargs echo -n \
ROOT_LENGTH=$(echo "$PARTED_OUT" | grep -e '^ 2'| xargs echo -n \ ROOT_LENGTH=$(echo "$PARTED_OUT" | grep -e '^ 2'| xargs echo -n \
| cut -d" " -f 4 | tr -d B) | cut -d" " -f 4 | tr -d B)
BOOT_DEV=$(losetup --show -f -o ${BOOT_OFFSET} --sizelimit ${BOOT_LENGTH} ${IMG_FILE}) BOOT_DEV=$(losetup --show -f -o "${BOOT_OFFSET}" --sizelimit "${BOOT_LENGTH}" "${IMG_FILE}")
ROOT_DEV=$(losetup --show -f -o ${ROOT_OFFSET} --sizelimit ${ROOT_LENGTH} ${IMG_FILE}) ROOT_DEV=$(losetup --show -f -o "${ROOT_OFFSET}" --sizelimit "${ROOT_LENGTH}" "${IMG_FILE}")
echo "/boot: offset $BOOT_OFFSET, length $BOOT_LENGTH" echo "/boot: offset $BOOT_OFFSET, length $BOOT_LENGTH"
echo "/: offset $ROOT_OFFSET, length $ROOT_LENGTH" echo "/: offset $ROOT_OFFSET, length $ROOT_LENGTH"
mkdir -p ${STAGE_WORK_DIR}/rootfs mkdir -p "${STAGE_WORK_DIR}/rootfs"
mkdir -p ${NOOBS_DIR} mkdir -p "${NOOBS_DIR}"
mount $ROOT_DEV ${STAGE_WORK_DIR}/rootfs mount "$ROOT_DEV" "${STAGE_WORK_DIR}/rootfs"
mount $BOOT_DEV ${STAGE_WORK_DIR}/rootfs/boot mount "$BOOT_DEV" "${STAGE_WORK_DIR}/rootfs/boot"
ln -sv "/lib/systemd/system/apply_noobs_os_config.service" "$ROOTFS_DIR/etc/systemd/system/multi-user.target.wants/apply_noobs_os_config.service" ln -sv "/lib/systemd/system/apply_noobs_os_config.service" "$ROOTFS_DIR/etc/systemd/system/multi-user.target.wants/apply_noobs_os_config.service"
bsdtar --format gnutar --use-compress-program pxz -C ${STAGE_WORK_DIR}/rootfs/boot -cpf ${NOOBS_DIR}/boot.tar.xz . bsdtar --numeric-owner --format gnutar --use-compress-program pxz -C "${STAGE_WORK_DIR}/rootfs/boot" -cpf "${NOOBS_DIR}/boot.tar.xz" .
umount ${STAGE_WORK_DIR}/rootfs/boot umount "${STAGE_WORK_DIR}/rootfs/boot"
bsdtar --format gnutar --use-compress-program pxz -C ${STAGE_WORK_DIR}/rootfs --one-file-system -cpf ${NOOBS_DIR}/root.tar.xz . bsdtar --numeric-owner --format gnutar --use-compress-program pxz -C "${STAGE_WORK_DIR}/rootfs" --one-file-system -cpf "${NOOBS_DIR}/root.tar.xz" .
unmount_image ${IMG_FILE} unmount_image "${IMG_FILE}"
View File
+3 -3
View File
@@ -1,5 +1,5 @@
log (){ log (){
date +"[%T] $@" | tee -a "${LOG_FILE}" date +"[%T] $*" | tee -a "${LOG_FILE}"
} }
export -f log export -f log
@@ -15,10 +15,10 @@ bootstrap(){
local BOOTSTRAP_CMD=debootstrap local BOOTSTRAP_CMD=debootstrap
fi fi
capsh --drop=cap_setfcap -- -c "${BOOTSTRAP_CMD} --components=main,contrib,non-free \ capsh --drop=cap_setfcap -- "${BOOTSTRAP_CMD}" --components=main,contrib,non-free \
--arch armhf \ --arch armhf \
--keyring "${STAGE_DIR}/files/raspberrypi.gpg" \ --keyring "${STAGE_DIR}/files/raspberrypi.gpg" \
$1 $2 $3" || rmdir "$2/debootstrap" "$1" "$2" "$3" || rmdir "$2/debootstrap"
} }
export -f bootstrap export -f bootstrap
+2 -2
View File
@@ -10,11 +10,11 @@ dependencies_check()
for depfile in "$@"; do for depfile in "$@"; do
if [[ -e "$depfile" ]]; then if [[ -e "$depfile" ]]; then
deps="$(sed -f "${SCRIPT_DIR}/remove-comments.sed" < ${BASE_DIR}/depends)" deps="$(sed -f "${SCRIPT_DIR}/remove-comments.sed" < "${BASE_DIR}/depends")"
fi fi
for dep in $deps; do for dep in $deps; do
if ! hash ${dep%:*} 2>/dev/null; then if ! hash "${dep%:*}" 2>/dev/null; then
missing="${missing:+$missing }${dep#*:}" missing="${missing:+$missing }${dep#*:}"
fi fi
done done
View File
+5 -5
View File
@@ -1,13 +1,13 @@
#!/bin/bash -e #!/bin/bash -e
install -m 644 files/sources.list ${ROOTFS_DIR}/etc/apt/ install -m 644 files/sources.list "${ROOTFS_DIR}/etc/apt/"
install -m 644 files/raspi.list ${ROOTFS_DIR}/etc/apt/sources.list.d/ install -m 644 files/raspi.list "${ROOTFS_DIR}/etc/apt/sources.list.d/"
if [ -n "$APT_PROXY" ]; then if [ -n "$APT_PROXY" ]; then
install -m 644 files/51cache ${ROOTFS_DIR}/etc/apt/apt.conf.d/51cache install -m 644 files/51cache "${ROOTFS_DIR}/etc/apt/apt.conf.d/51cache"
sed ${ROOTFS_DIR}/etc/apt/apt.conf.d/51cache -i -e "s|APT_PROXY|${APT_PROXY}|" sed "${ROOTFS_DIR}/etc/apt/apt.conf.d/51cache" -i -e "s|APT_PROXY|${APT_PROXY}|"
else else
rm -f ${ROOTFS_DIR}/etc/apt/apt.conf.d/51cache rm -f "${ROOTFS_DIR}/etc/apt/apt.conf.d/51cache"
fi fi
on_chroot apt-key add - < files/raspberrypi.gpg.key on_chroot apt-key add - < files/raspberrypi.gpg.key
+2 -2
View File
@@ -1,3 +1,3 @@
deb http://mirrordirector.raspbian.org/raspbian/ stretch main contrib non-free rpi deb http://raspbian.raspberrypi.org/raspbian/ stretch main contrib non-free rpi
# Uncomment line below then 'apt-get update' to enable 'apt-get source' # Uncomment line below then 'apt-get update' to enable 'apt-get source'
#deb-src http://archive.raspbian.org/raspbian/ stretch main contrib non-free rpi #deb-src http://raspbian.raspberrypi.org/raspbian/ stretch main contrib non-free rpi
+1
View File
@@ -1 +1,2 @@
raspberrypi-bootloader raspberrypi-bootloader
raspberrypi-kernel
+2 -2
View File
@@ -1,5 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d "${ROOTFS_DIR}" ]; then
bootstrap stretch ${ROOTFS_DIR} http://mirrordirector.raspbian.org/raspbian/ bootstrap stretch "${ROOTFS_DIR}" http://raspbian.raspberrypi.org/raspbian/
fi fi
+2 -2
View File
@@ -1,4 +1,4 @@
#!/bin/bash -e #!/bin/bash -e
install -m 644 files/cmdline.txt ${ROOTFS_DIR}/boot/ install -m 644 files/cmdline.txt "${ROOTFS_DIR}/boot/"
install -m 644 files/config.txt ${ROOTFS_DIR}/boot/ install -m 644 files/config.txt "${ROOTFS_DIR}/boot/"
+3 -4
View File
@@ -1,9 +1,8 @@
#!/bin/bash -e #!/bin/bash -e
install -d ${ROOTFS_DIR}/etc/systemd/system/[email protected] install -d "${ROOTFS_DIR}/etc/systemd/system/[email protected]"
install -m 644 files/noclear.conf ${ROOTFS_DIR}/etc/systemd/system/[email protected]/noclear.conf install -m 644 files/noclear.conf "${ROOTFS_DIR}/etc/systemd/system/[email protected]/noclear.conf"
install -m 744 files/policy-rc.d ${ROOTFS_DIR}/usr/sbin/policy-rc.d #TODO: Necessary in systemd? install -v -m 644 files/fstab "${ROOTFS_DIR}/etc/fstab"
install -v -m 644 files/fstab ${ROOTFS_DIR}/etc/fstab
on_chroot << EOF on_chroot << EOF
if ! id -u pi >/dev/null 2>&1; then if ! id -u pi >/dev/null 2>&1; then
-3
View File
@@ -1,3 +0,0 @@
#!/bin/sh
exit 101
+1
View File
@@ -0,0 +1 @@
netbase
+3 -5
View File
@@ -1,8 +1,6 @@
#!/bin/bash -e #!/bin/bash -e
install -m 644 files/ipv6.conf ${ROOTFS_DIR}/etc/modprobe.d/ipv6.conf install -m 644 files/ipv6.conf "${ROOTFS_DIR}/etc/modprobe.d/ipv6.conf"
install -m 644 files/hostname ${ROOTFS_DIR}/etc/hostname install -m 644 files/hostname "${ROOTFS_DIR}/etc/hostname"
on_chroot << EOF ln -sf /dev/null "${ROOTFS_DIR}/etc/systemd/network/99-default.link"
dpkg-divert --add --local /lib/udev/rules.d/75-persistent-net-generator.rules
EOF
+1 -1
View File
@@ -1,5 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d "${ROOTFS_DIR}" ]; then
copy_previous copy_previous
fi fi
-3
View File
@@ -1,3 +0,0 @@
#!/bin/bash -e
touch ${ROOTFS_DIR}/spindle_install
-3
View File
@@ -1,3 +0,0 @@
#!/bin/bash -e
rm -f ${ROOTFS_DIR}/spindle_install
+2
View File
@@ -20,3 +20,5 @@ rpi-update
libmtp-runtime libmtp-runtime
rsync rsync
htop htop
man-db
policykit-1
@@ -1,15 +0,0 @@
Index: jessie-stage2/rootfs/etc/rc.local
===================================================================
--- jessie-stage2.orig/rootfs/etc/rc.local
+++ jessie-stage2/rootfs/etc/rc.local
@@ -11,4 +11,10 @@
#
# By default this script does nothing.
+# Print the IP address
+_IP=$(hostname -I) || true
+if [ "$_IP" ]; then
+ printf "My IP address is %s\n" "$_IP"
+fi
+
exit 0
+20 -8
View File
@@ -1,15 +1,15 @@
#!/bin/bash -e #!/bin/bash -e
install -m 755 files/resize2fs_once ${ROOTFS_DIR}/etc/init.d/ install -m 755 files/resize2fs_once "${ROOTFS_DIR}/etc/init.d/"
install -d ${ROOTFS_DIR}/etc/systemd/system/rc-local.service.d install -d "${ROOTFS_DIR}/etc/systemd/system/rc-local.service.d"
install -m 644 files/ttyoutput.conf ${ROOTFS_DIR}/etc/systemd/system/rc-local.service.d/ install -m 644 files/ttyoutput.conf "${ROOTFS_DIR}/etc/systemd/system/rc-local.service.d/"
install -m 644 files/50raspi ${ROOTFS_DIR}/etc/apt/apt.conf.d/ install -m 644 files/50raspi "${ROOTFS_DIR}/etc/apt/apt.conf.d/"
install -m 644 files/console-setup ${ROOTFS_DIR}/etc/default/ install -m 644 files/console-setup "${ROOTFS_DIR}/etc/default/"
install -m 755 files/rc.local ${ROOTFS_DIR}/etc/ install -m 755 files/rc.local "${ROOTFS_DIR}/etc/"
on_chroot << EOF on_chroot << EOF
systemctl disable hwclock.sh systemctl disable hwclock.sh
@@ -17,12 +17,24 @@ systemctl disable nfs-common
systemctl disable rpcbind systemctl disable rpcbind
systemctl disable ssh systemctl disable ssh
systemctl enable regenerate_ssh_host_keys systemctl enable regenerate_ssh_host_keys
EOF
if [ "${USE_QEMU}" = "1" ]; then
echo "enter QEMU mode"
install -m 644 files/90-qemu.rules "${ROOTFS_DIR}/etc/udev/rules.d/"
on_chroot << EOF
systemctl disable resize2fs_once
EOF
echo "leaving QEMU mode"
else
on_chroot << EOF
systemctl enable resize2fs_once systemctl enable resize2fs_once
EOF EOF
fi
on_chroot << \EOF on_chroot << \EOF
for GRP in input spi i2c gpio; do for GRP in input spi i2c gpio; do
groupadd -f -r $GRP groupadd -f -r "$GRP"
done done
for GRP in adm dialout cdrom audio users sudo video games plugdev input gpio spi i2c netdev; do for GRP in adm dialout cdrom audio users sudo video games plugdev input gpio spi i2c netdev; do
adduser pi $GRP adduser pi $GRP
@@ -37,4 +49,4 @@ on_chroot << EOF
usermod --pass='*' root usermod --pass='*' root
EOF EOF
rm -f ${ROOTFS_DIR}/etc/ssh/ssh_host_*_key* rm -f "${ROOTFS_DIR}/etc/ssh/"ssh_host_*_key*
+3
View File
@@ -0,0 +1,3 @@
KERNEL=="sda", SYMLINK+="mmcblk0"
KERNEL=="sda?", SYMLINK+="mmcblk0p%n"
KERNEL=="sda2", SYMLINK+="root"
+1
View File
@@ -1,3 +1,4 @@
wpasupplicant wireless-tools firmware-atheros firmware-brcm80211 firmware-libertas firmware-misc-nonfree firmware-realtek wpasupplicant wireless-tools firmware-atheros firmware-brcm80211 firmware-libertas firmware-misc-nonfree firmware-realtek
raspberrypi-net-mods raspberrypi-net-mods
dhcpcd5 dhcpcd5
net-tools
+4 -4
View File
@@ -1,8 +1,8 @@
#!/bin/bash -e #!/bin/bash -e
install -v -d ${ROOTFS_DIR}/etc/systemd/system/dhcpcd.service.d install -v -d "${ROOTFS_DIR}/etc/systemd/system/dhcpcd.service.d"
install -v -m 644 files/wait.conf ${ROOTFS_DIR}/etc/systemd/system/dhcpcd.service.d/ install -v -m 644 files/wait.conf "${ROOTFS_DIR}/etc/systemd/system/dhcpcd.service.d/"
install -v -d ${ROOTFS_DIR}/etc/wpa_supplicant install -v -d "${ROOTFS_DIR}/etc/wpa_supplicant"
install -v -m 600 files/wpa_supplicant.conf ${ROOTFS_DIR}/etc/wpa_supplicant/ install -v -m 600 files/wpa_supplicant.conf "${ROOTFS_DIR}/etc/wpa_supplicant/"
@@ -1,3 +1,2 @@
country=GB
ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev ctrl_interface=DIR=/var/run/wpa_supplicant GROUP=netdev
update_config=1 update_config=1
+3
View File
@@ -1 +1,4 @@
IMG_SUFFIX="-lite" IMG_SUFFIX="-lite"
if [ "${USE_QEMU}" = "1" ]; then
export IMG_SUFFIX="${IMG_SUFFIX}-qemu"
fi
+1 -1
View File
@@ -1,5 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d "${ROOTFS_DIR}" ]; then
copy_previous copy_previous
fi fi
+4 -1
View File
@@ -1,5 +1,5 @@
gstreamer1.0-x gstreamer1.0-omx gstreamer1.0-plugins-base gstreamer1.0-plugins-good gstreamer1.0-plugins-bad gstreamer1.0-alsa gstreamer1.0-libav gstreamer1.0-x gstreamer1.0-omx gstreamer1.0-plugins-base gstreamer1.0-plugins-good gstreamer1.0-plugins-bad gstreamer1.0-alsa gstreamer1.0-libav
xpdf gtk2-engines alsa-utils qpdfview gtk2-engines alsa-utils
desktop-base desktop-base
git git
omxplayer omxplayer
@@ -9,3 +9,6 @@ gvfs
rfkill rfkill
chromium-browser rpi-chromium-mods chromium-browser rpi-chromium-mods
gldriver-test gldriver-test
fonts-droid-fallback
fonts-liberation2
obconf
+1 -1
View File
@@ -1,3 +1,3 @@
#!/bin/bash -e #!/bin/bash -e
rm -f ${ROOTFS_DIR}/etc/systemd/system/dhcpcd.service.d/wait.conf rm -f "${ROOTFS_DIR}/etc/systemd/system/dhcpcd.service.d/wait.conf"
+1 -1
View File
@@ -1,5 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d "${ROOTFS_DIR}" ]; then
copy_previous copy_previous
fi fi
+2 -4
View File
@@ -8,18 +8,14 @@ python-serial python3-serial
python-picamera python3-picamera python-picamera python3-picamera
debian-reference-en dillo x2x debian-reference-en dillo x2x
raspberrypi-net-mods raspberrypi-ui-mods raspberrypi-net-mods raspberrypi-ui-mods
fonts-liberation2
smartsim smartsim
python-pip python3-pip python-pip python3-pip
python3-numpy python3-numpy
pypy pypy
minecraft-pi python-minecraftpi minecraft-pi python-minecraftpi
alacarte rc-gui sense-hat alacarte rc-gui sense-hat
claws-mail
tree tree
scratch nuscratch scratch nuscratch
greenfoot bluej
nodered
libgl1-mesa-dri libgles1-mesa libgles2-mesa xcompmgr libgl1-mesa-dri libgles1-mesa libgles2-mesa xcompmgr
geany geany
piclone piclone
@@ -33,3 +29,5 @@ python-sense-emu python3-sense-emu sense-emu-tools python-sense-emu-doc
pprompt pprompt
scratch2 scratch2
python3-thonny python3-thonny
piwiz
rp-prefapps
+2 -2
View File
@@ -1,4 +1,4 @@
libreoffice libreoffice-gtk libreoffice-pi
timidity timidity
pi-package pi-package
realvnc-vnc-server realvnc-vnc-viewer realvnc-vnc-server
+3
View File
@@ -17,3 +17,6 @@ python-scrollphathd python3-scrollphathd
python-sn3218 python3-sn3218 python-sn3218 python3-sn3218
python-skywriter python3-skywriter python-skywriter python3-skywriter
python-touchphat python3-touchphat python-touchphat python3-touchphat
python-buttonshim python3-buttonshim
python-unicornhathd python3-unicornhathd
python-pantilthat python3-pantilthat
+2 -1
View File
@@ -1,3 +1,4 @@
#!/bin/bash -e #!/bin/bash -e
ln -sf /etc/systemd/system/[email protected] ${ROOTFS_DIR}/etc/systemd/system/getty.target.wants/[email protected] ln -sf /etc/systemd/system/[email protected] \
"${ROOTFS_DIR}/etc/systemd/system/getty.target.wants/[email protected]"
+8 -16
View File
@@ -1,30 +1,22 @@
#!/bin/bash -e #!/bin/bash -e
HASH=`wget https://api.github.com/repos/KenT2/python-games/git/refs/heads/master -qO -| grep \"sha\" | cut -f 2 -d ':' | cut -f 2 -d \"` HASH="$(wget https://api.github.com/repos/KenT2/python-games/git/refs/heads/master -qO -| grep \"sha\" | cut -f 2 -d ':' | cut -f 2 -d \")"
if [ -f files/python_games.hash ]; then if [ -f files/python_games.hash ]; then
HASH_LOCAL=`cat files/python_games.hash` HASH_LOCAL="$(cat files/python_games.hash)"
fi fi
if [ ! -e files/python_games.tar.gz ] || [ "$HASH" != "$HASH_LOCAL" ]; then if [ ! -e files/python_games.tar.gz ] || [ "$HASH" != "$HASH_LOCAL" ]; then
wget "https://github.com/KenT2/python-games/tarball/master" -O files/python_games.tar.gz wget "https://github.com/KenT2/python-games/tarball/master" -O files/python_games.tar.gz
echo $HASH > files/python_games.hash echo "$HASH" > files/python_games.hash
fi fi
ln -sf pip3 ${ROOTFS_DIR}/usr/bin/pip-3.2 ln -sf pip3 "${ROOTFS_DIR}/usr/bin/pip-3.2"
install -v -o 1000 -g 1000 -d ${ROOTFS_DIR}/home/pi/python_games install -v -o 1000 -g 1000 -d "${ROOTFS_DIR}/home/pi/python_games"
tar xvf files/python_games.tar.gz -C ${ROOTFS_DIR}/home/pi/python_games --strip-components=1 tar xvf files/python_games.tar.gz -C "${ROOTFS_DIR}/home/pi/python_games" --strip-components=1
chown 1000:1000 ${ROOTFS_DIR}/home/pi/python_games -Rv chown 1000:1000 "${ROOTFS_DIR}/home/pi/python_games" -Rv
chmod +x ${ROOTFS_DIR}/home/pi/python_games/launcher.sh chmod +x "${ROOTFS_DIR}/home/pi/python_games/launcher.sh"
install -v -o 1000 -g 1000 -d "${ROOTFS_DIR}/home/pi/Documents"
install -v -o 1000 -g 1000 -d "${ROOTFS_DIR}/home/pi/Documents/BlueJ Projects"
install -v -o 1000 -g 1000 -d "${ROOTFS_DIR}/home/pi/Documents/Greenfoot Projects"
install -v -o 1000 -g 1000 -d "${ROOTFS_DIR}/home/pi/Documents/Scratch Projects"
rsync -a --chown=1000:1000 ${ROOTFS_DIR}/usr/share/doc/BlueJ/ "${ROOTFS_DIR}/home/pi/Documents/BlueJ Projects"
rsync -a --chown=1000:1000 ${ROOTFS_DIR}/usr/share/doc/Greenfoot/ "${ROOTFS_DIR}/home/pi/Documents/Greenfoot Projects"
rsync -a --chown=1000:1000 ${ROOTFS_DIR}/usr/share/scratch/Projects/Demos/ "${ROOTFS_DIR}/home/pi/Documents/Scratch Projects"
#Alacarte fixes #Alacarte fixes
install -v -o 1000 -g 1000 -d "${ROOTFS_DIR}/home/pi/.local" install -v -o 1000 -g 1000 -d "${ROOTFS_DIR}/home/pi/.local"
+16
View File
@@ -0,0 +1,16 @@
#!/bin/sh -e
magpi_regex="MagPi[[:digit:]]*.pdf"
magpi_loc="https://www.raspberrypi.org/magpi-issues"
magpi_latest="$(curl "$magpi_loc/?C=M;O=D" -s | grep "$magpi_regex" -m 1 -o | head -n 1)"
if [ ! -f "files/$magpi_latest" ]; then
find files/ -regextype grep -regex "files/$magpi_regex" -delete
wget "$magpi_loc/$magpi_latest" -O "files/$magpi_latest"
fi
file "files/$magpi_latest" | grep -q "PDF document"
install -v -o 1000 -g 1000 -d "${ROOTFS_DIR}/home/pi/MagPi"
install -v -o 1000 -g 1000 -m 644 "files/$magpi_latest" "${ROOTFS_DIR}/home/pi/MagPi/"
+1
View File
@@ -0,0 +1 @@
*.pdf
+3
View File
@@ -1 +1,4 @@
IMG_SUFFIX="-4GB" IMG_SUFFIX="-4GB"
if [ "${USE_QEMU}" = "1" ]; then
export IMG_SUFFIX="${IMG_SUFFIX}-qemu"
fi
+1 -1
View File
@@ -1,5 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d "${ROOTFS_DIR}" ]; then
copy_previous copy_previous
fi fi
+3
View File
@@ -1 +1,4 @@
IMG_SUFFIX="" IMG_SUFFIX=""
if [ "${USE_QEMU}" = "1" ]; then
export IMG_SUFFIX="${IMG_SUFFIX}-qemu"
fi
+1 -1
View File
@@ -1,5 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d "${ROOTFS_DIR}" ]; then
copy_previous copy_previous
fi fi